%define maj 8
%define min 12
%define rel 11
%define rev 16

Summary:     Powerful and flexible Mail Transport Agent
Name:        sendmail
Version:     %{maj}.%{min}.%{rel}
Release:     %{rev}.pp
License:     Sendmail
Group:       System Environment/Daemons
Source0:     ftp://ftp.sendmail.org/pub/%{name}/%{name}.%{version}.tar.gz
Source1:     site.Linux.m4
Source2:     site.Linux.m4.mta
Source3:     %{name}.init
Source4:     %{name}.sysconfig
Source5:     Makefile.db
Source6:     %{name}.access
Source7:     %{name}.aliases
Source8:     %{name}.domaintable
Source9:     %{name}.genericstable
Source10:    %{name}.mailertable
Source11:    %{name}.virtusertable
Source12:    %{name}.trust
Source13:    %{name}.hostnames
Source14:    %{name}.mc
Source15:    submit.mc
Source16:    set-clt-perms.sh
Source17:    set-srv-perms.sh
Source18:    smtp.pamd
Patch0:      %{name}-security.patch
URL:         http://www.sendmail.org/
Buildroot:   /var/tmp/%{name}-root
Vendor:      Peter Pramberger
Packager:    Peter Pramberger <peter.pramberger@1012surf.net>
Prereq:      /usr/sbin/groupadd /usr/sbin/useradd /bin/grep /usr/bin/make
Prereq:      /sbin/chkconfig
Requires:    %{name}-client = %{version}-%{release} %{name}-client.pp
Requires:    cyrus-sasl.pp openldap
Provides:    %{name}.pp MTA smtpd smtpdaemon /usr/sbin/sm-mta
Obsoletes:   postfix exim qmail
BuildPrereq: gcc >= 2.96 /bin/mkdir /usr/bin/make /usr/bin/install /bin/ln
BuildPrereq: cyrus-sasl-devel.pp openssl-devel pam-devel openldap-devel
BuildPrereq: db3-devel m4
ExclusiveOS: linux

%description
Sendmail is a Mail Transfer Agent, which is the program that
moves mail from one machine to another. Sendmail implements
a general internetwork mail routing facility, featuring
aliasing and forwarding, automatic routing to network gateways
and flexible configuration.


%package client
Summary:     Mail submission program
Group:       Console/Tools
Prereq:      /usr/sbin/groupadd /usr/sbin/useradd /bin/cat /bin/grep
Prereq:      /bin/touch /bin/chmod /bin/chown
Requires:    openssl pam db3
Provides:    %{name}-client.pp /usr/sbin/sendmail /usr/bin/mailq

%package config
Summary:     M4 configuration tools for sendmail
Group:       Console/Tools
Requires:    %{name}-client = %{version}-%{release} %{name}-client.pp
Requires:    m4
Provides:    %{name}-config.pp

%package devel
Summary:     The development environment for Sendmail Milter
Group:       Development/Libraries
Provides:    %{name}-devel.pp


%description client
This package contains the mail submission part of Sendmail
used to initially send mails.

%description config
This package contains the M4 configuration tools and files
for compiling sendmail source configs (.mc) to the sendmail
format (.cf).

%description devel
The sendmail-devel package contains the development
libraries and header files to build filters for sendmail.


%prep
%setup -q
%patch0 -p1
# replace wrong location of perl
for file in `find . -type f -exec fgrep -l /bin/perl {} \;`; do
   cp -f $file tmpfile
   sed -e 's+#!/user/local/bin/perl+#!/usr/bin/perl+g' \
       -e 's+#!/usr/local/bin/perl+#!/usr/bin/perl+g' \
       -e 's+#!/bin/perl+#!/usr/bin/perl+g' tmpfile > $file
   rm -f tmpfile
done
# replace wrong location of sh
for file in `find . -type f -exec fgrep -l /sbin/sh {} \;`; do
   cp -f $file tmpfile
   sed -e 's+/sbin/sh+/bin/sh+g' tmpfile > $file
   rm -f tmpfile
done
# sendmail config
sed -e 's+XXXReplaceXXX+%{maj}%{min}%{rel}%{rev}+g' \
	$RPM_SOURCE_DIR/sendmail.mc > cf/cf/sendmail.mc
sed -e 's+XXXReplaceXXX+%{maj}%{min}%{rel}%{rev}+g' \
	$RPM_SOURCE_DIR/submit.mc > cf/cf/submit.mc
# build config
sed -e "s+XXOPTFLAGSXX+$RPM_OPT_FLAGS+g" \
	$RPM_SOURCE_DIR/site.Linux.m4 > devtools/Site/site.Linux.m4
sed -e "s+XXOPTFLAGSXX+$RPM_OPT_FLAGS+g" \
	$RPM_SOURCE_DIR/site.Linux.m4.mta > devtools/Site/site.Linux.m4.mta


%build
cp sendmail/main.c tmp_file
sed -e 's+cftype = SM_GET_RIGHT_CF;+cftype = SM_GET_SUBMIT_CF;+g' \
	tmp_file > sendmail/main.c
rm -f tmp_file
CFLAGS="$RPM_OPT_FLAGS" \
        sh Build -c


%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/mail
mkdir -p $RPM_BUILD_ROOT/etc/smrsh
mkdir -p $RPM_BUILD_ROOT/etc/pam.d
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/sysconfig
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/lib
mkdir -p $RPM_BUILD_ROOT/usr/libexec/sendmail
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man1
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man5
mkdir -p $RPM_BUILD_ROOT/usr/share/man/man8
mkdir -p $RPM_BUILD_ROOT/usr/share/sendmail
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/var
sh Build DESTDIR=$RPM_BUILD_ROOT install
sh Build DESTDIR=$RPM_BUILD_ROOT install-docs
cd sendmail
sh Build DESTDIR=$RPM_BUILD_ROOT install-sendmail
cd ..
# site configuration
mv -f devtools/Site/site.Linux.m4.mta devtools/Site/site.Linux.m4
cp sendmail/main.c tmp_file
sed -e 's+cftype = SM_GET_SUBMIT_CF;+cftype = SM_GET_SENDMAIL_CF;+g' \
	tmp_file > sendmail/main.c
rm -f tmp_file
CFLAGS="$RPM_OPT_FLAGS" \
        sh Build -c
cd sendmail
sh Build DESTDIR=$RPM_BUILD_ROOT install-sm-mta
cd ../smrsh
sh Build DESTDIR=$RPM_BUILD_ROOT install-smrsh
cd ../libmilter
CFLAGS="$RPM_OPT_FLAGS" \
	sh Build -c
sh Build DESTDIR=$RPM_BUILD_ROOT install
cd ..
make -C cf/cf clean
make -C cf/cf DESTDIR=$RPM_BUILD_ROOT CFOWN=root CFGRP=root CFMODE=0640 install-cf
install -m 0755 $RPM_SOURCE_DIR/sendmail.init $RPM_BUILD_ROOT/etc/rc.d/init.d/sendmail
install -m 0600 $RPM_SOURCE_DIR/sendmail.sysconfig $RPM_BUILD_ROOT/etc/sysconfig/sendmail
install -m 0600 $RPM_SOURCE_DIR/Makefile.db $RPM_BUILD_ROOT/etc/mail/Makefile
install -m 0640 $RPM_SOURCE_DIR/sendmail.access $RPM_BUILD_ROOT/etc/mail/access
install -m 0640 $RPM_SOURCE_DIR/sendmail.aliases $RPM_BUILD_ROOT/etc/mail/aliases
install -m 0640 $RPM_SOURCE_DIR/sendmail.domaintable $RPM_BUILD_ROOT/etc/mail/domaintable
install -m 0640 $RPM_SOURCE_DIR/sendmail.genericstable $RPM_BUILD_ROOT/etc/mail/genericstable
install -m 0640 $RPM_SOURCE_DIR/sendmail.mailertable $RPM_BUILD_ROOT/etc/mail/mailertable
install -m 0640 $RPM_SOURCE_DIR/sendmail.virtusertable $RPM_BUILD_ROOT/etc/mail/virtusertable
install -m 0640 $RPM_SOURCE_DIR/sendmail.trust $RPM_BUILD_ROOT/etc/mail/trusted-users
install -m 0640 $RPM_SOURCE_DIR/sendmail.hostnames $RPM_BUILD_ROOT/etc/mail/local-host-names
install -m 0700 $RPM_SOURCE_DIR/set-*-perms.sh $RPM_BUILD_ROOT/usr/libexec/sendmail
install -m 0644 $RPM_SOURCE_DIR/smtp.pamd $RPM_BUILD_ROOT/etc/pam.d/smtp
chown root:root $RPM_BUILD_ROOT/usr/sbin/sm-mta
chmod 0500 $RPM_BUILD_ROOT/usr/sbin/sm-mta
ln -sf mail/aliases $RPM_BUILD_ROOT/etc
ln -sf mail/sendmail.cf $RPM_BUILD_ROOT/etc
ln -sf mail/submit.cf $RPM_BUILD_ROOT/etc
ln -sf /usr/sbin/sendmail $RPM_BUILD_ROOT/usr/lib
cp -rpf devtools cf $RPM_BUILD_ROOT/usr/share/sendmail
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/mail.local.*
rm -f $RPM_BUILD_ROOT/usr/share/man/man8/rmail.*
rm -rf $RPM_BUILD_ROOT/var


%post
if ! grep sendmail /etc/group > /dev/null 2>&1; then
   /usr/sbin/groupadd -r sendmail > /dev/null 2>&1
fi
if ! grep sendmail /etc/passwd > /dev/null 2>&1; then
   /usr/sbin/useradd -g sendmail -G sendmail -d /var/spool/mqueue \
        -r -s /dev/null sendmail > /dev/null 2>&1
fi
/usr/libexec/sendmail/set-srv-perms.sh
/usr/bin/make -C /etc/mail
/sbin/chkconfig --add sendmail
/sbin/chkconfig sendmail on
if [ -s /etc/mail/sendmail.cf ]; then
   if [ -f /var/lock/subsys/sendmail ]; then
      /etc/rc.d/init.d/sendmail restart
   fi
fi

%post client
if ! grep smmsp /etc/group > /dev/null 2>&1; then
   /usr/sbin/groupadd -r smmsp > /dev/null 2>&1
fi
if ! grep smmsp /etc/passwd > /dev/null 2>&1; then
   /usr/sbin/useradd -g smmsp -G smmsp -d /var/spool/clientmqueue \
        -r -s /dev/null smmsp > /dev/null 2>&1
fi
/usr/libexec/sendmail/set-clt-perms.sh
/bin/ln -sf submit.cf /etc/mail/sendmail.cf


%preun
if [ $1 = 0 ] ; then
   /sbin/chkconfig sendmail off
   /sbin/chkconfig --del sendmail
   if [ -f /var/lock/subsys/sendmail ]; then
      /etc/rc.d/init.d/sendmail stop
   fi
   make -C /etc/mail clean
fi

%preun client
rm -f /etc/mail/sendmail.cf


%postun
/bin/ln -sf submit.cf /etc/mail/sendmail.cf
/usr/libexec/sendmail/set-clt-perms.sh
rm -f /usr/bin/newaliases

%postun client
rm -f /usr/bin/hoststat
rm -f /usr/bin/mailq
rm -f /usr/bin/purgestat


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc FAQ INSTALL KNOWNBUGS LICENSE PGPKEYS README RELEASE_NOTES
%doc %dir contrib doc libmilter/README
%doc %dir smrsh/README sendmail/README sendmail/SECURITY
%doc %dir sendmail/TRACEFLAGS sendmail/TUNING libsm/README
%config /etc/mail/sendmail.cf
%config /etc/mail/access
%config /etc/mail/aliases
%config /etc/mail/domaintable
%config /etc/mail/genericstable
%config /etc/mail/mailertable
%config /etc/mail/virtusertable
%config /etc/mail/local-host-names
%config /etc/mail/Makefile
/etc/mail/helpfile
/etc/aliases
/etc/rc.d/init.d/sendmail
%config /etc/sysconfig/sendmail
%config /etc/pam.d/smtp
/usr/bin/vacation
%config /etc/smrsh
/usr/share/man/man1/vacation.*
/usr/share/man/man1/newaliases.*
/usr/share/man/man5/*
/usr/share/man/man8/editmap.*
/usr/share/man/man8/makemap.*
/usr/share/man/man8/praliases.*
/usr/share/man/man8/smrsh.*
/usr/share/man/man8/sendmail.*
/usr/sbin/editmap
/usr/sbin/makemap
/usr/sbin/praliases
/usr/sbin/smrsh
/usr/sbin/sm-mta
/usr/libexec/sendmail/set-srv-perms.sh

%files client
%defattr(-,root,root)
%config /etc/mail/submit.cf
%config /etc/mail/trusted-users
/etc/*.cf
/usr/share/man/man1/mailq.*
/usr/share/man/man8/mailstats.*
/usr/sbin/sendmail
/usr/sbin/mailstats
/usr/lib/sendmail
/usr/libexec/sendmail/set-clt-perms.sh

%files config
%defattr(-,root,root)
%config /usr/share/sendmail

%files devel
%defattr(-,root,root)
/usr/lib/*.*a
/usr/include/*


%changelog
* Wed Feb 03 2004 peter.pramberger@1012surf.net
- new version 8.12.13
- added _FFR_DEAL_WITH_ERROR_SSL to prevent log loop

* Fri Sep 19 2003 peter.pramberger@1012surf.net
- new version 8.12.10 (security bugfix)
- man pages moved to /usr/share/man

* Mon Jun 02 2003 peter.pramberger@1012surf.net
- compiled for RH73

* Fri Apr 18 2003 peter.pramberger@1012surf.net
- bugfixes in /etc/mail/Makefile
- added devel package

* Mon Mar 31 2003 peter.pramberger@1012surf.net
- new version 8.12.9 (security bugfix)

* Tue Mar 04 2003 peter.pramberger@1012surf.net
- new version 8.12.8 (security bugfix)

* Sun Jan 19 2003 peter.pramberger@1012surf.net
- new version 8.12.7

* Fri Dec 27 2002 peter.pramberger@1012surf.net
- added patch for security bug in DNS resolving
- fix file permissions
- SHM now functioning with new kernel

* Sun Oct 06 2002 peter.pramberger@1012surf.net
- added patch for security bug in smrsh
- moved /usr/libexec/sendmail/smrsh.bin to /etc/smrsh

* Tue Oct 01 2002 peter.pramberger@1012surf.net
- fixed sasl link bug

* Sun Sep 29 2002 peter.pramberger@1012surf.net
- created

